/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "elographicsdriverclass.h"

elographicsDriverClass::elographicsDriverClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :eloClass(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;

if (x->getOption("InputDevice", sectNum, "DeviceName") != "") { kLineEdit2->setText(x->getOption("InputDevice", sectNum, "DeviceName")); }
if (x->getOption("InputDevice", sectNum, "PortraitMode") == "Landscape") { kComboBox1->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "PortraitMode") == "Portrait") { kComboBox1->setCurrentItem(1); }
if (x->getOption("InputDevice", sectNum, "PortraitMode") == "PortraitCCW") { kComboBox1->setCurrentItem(2); }
if (x->checkOption("InputDevice", sectNum, "SwapXY")) { checkBox1->setChecked(TRUE); }

if (x->getOption("InputDevice", sectNum, "ScreenNo") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "ScreenNo").toInt(&ok, 10);
kIntSpinBox5->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "UntouchDelay") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "UntouchDelay").toInt(&ok, 10);
kIntSpinBox1_5->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "ReportDelay") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "ReportDelay").toInt(&ok, 10);
kIntSpinBox1_2_2->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MinX") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "MinX").toInt(&ok, 10);
kIntSpinBox1->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MaxX") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "MaxX").toInt(&ok, 10);
kIntSpinBox1_2->setValue(a);
}



if (x->getOption("InputDevice", sectNum, "MinY") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "MinY").toInt(&ok, 10);
kIntSpinBox1_3->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MaxY") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "MaxY").toInt(&ok, 10);
kIntSpinBox1_4->setValue(a);
}

}


void elographicsDriverClass :: accept()
{
x->saveOption("InputDevice", sectNum, "DeviceName", 1, kLineEdit2->text());
if (kComboBox1->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "PortraitMode", 1, "Landscape"); }
if (kComboBox1->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "PortraitMode", 1, "Portrait"); }
if (kComboBox1->currentItem() == 2) { x->saveOption("InputDevice", sectNum, "PortraitMode", 1, "PortraitCCW"); }

if (checkBox1->isChecked()) { x->saveOption("InputDevice", sectNum, "SwapXY", 1, "True"); }
if (!checkBox1->isChecked()) { x->removeOption("InputDevice", sectNum, "SwapXY"); }

QString num;

num = num.setNum(kIntSpinBox5->value(), 10);
x->saveOption("InputDevice", sectNum, "ScreenNo", 1, num);
num = num.setNum(kIntSpinBox1_5->value(), 10);
x->saveOption("InputDevice", sectNum, "UntouchDelay", 1, num);
num = num.setNum(kIntSpinBox1_2_2->value(), 10);
x->saveOption("InputDevice", sectNum, "ReportDelay", 1, num);

num = num.setNum(kIntSpinBox1->value(), 10);
x->saveOption("InputDevice", sectNum, "MinX", 1, num);
num = num.setNum(kIntSpinBox1_2->value(), 10);
x->saveOption("InputDevice", sectNum, "MaxX", 1, num);
num = num.setNum(kIntSpinBox1_3->value(), 10);
x->saveOption("InputDevice", sectNum, "MinY", 1, num);
num = num.setNum(kIntSpinBox1_4->value(), 10);
x->saveOption("InputDevice", sectNum, "MaxY", 1, num);

close();
}





QString elographicsDriverClass :: returnXorg()
{
return x->returnConfig();
}









#include "elographicsdriverclass.moc"
