/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "fbdevdialogclass.h"

fbDevDialogClass::fbDevDialogClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :fbDevDialogWindow(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;
if (x->getOption("Device", sectNum, "fbdev") != "")
{
kLineEdit1->setText(x->getOption("Device", sectNum, "fbdev"));
}

if (x->checkOption("Device", sectNum, "ShadowFB")) { checkBox1->setChecked(TRUE); }
if (x->getOption("Device", sectNum, "Rotate") == "CW") { kComboBox1->setCurrentItem(1); }
if (x->getOption("Device", sectNum, "Rotate") == "UD") { kComboBox1->setCurrentItem(2); }
if (x->getOption("Device", sectNum, "Rotate") == "CCW") { kComboBox1->setCurrentItem(3); }
}

QString fbDevDialogClass :: returnXorg()
{
return x->returnConfig();
}

void fbDevDialogClass :: accept()
{
if (checkBox1->isChecked()) { x->saveOption("Device", sectNum, "ShadowFB", 1, "True"); }
if (!checkBox1->isChecked()) { x->removeOption("Device", sectNum, "ShadowFB"); }
x->saveOption("Device", sectNum, "fbdev", 1, kLineEdit1->text());
if (kComboBox1->currentItem() == 0) { x->removeOption("Device", sectNum, "Rotate"); }
if (kComboBox1->currentItem() == 1) { x->saveOption("Device", sectNum, "Rotate", 1, "CW"); }
if (kComboBox1->currentItem() == 2) { x->saveOption("Device", sectNum, "Rotate", 1, "UD"); }
if (kComboBox1->currentItem() == 3) { x->saveOption("Device", sectNum, "Rotate", 1, "CCW"); }
close();
}



#include "fbdevdialogclass.moc"
