/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "fpitdriverclass.h"

fpitDriverClass::fpitDriverClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :fpitClass(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;
kLineEdit2->setText(x->getOption("InputDevice", sectNum, "DeviceName"));
if (x->getOption("InputDevice", sectNum, "BaudRate") == "38400") { kComboBox2->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "BaudRate") == "19200") { kComboBox2->setCurrentItem(1); }
if (x->getOption("InputDevice", sectNum, "BaudRate") == "9600") { kComboBox2->setCurrentItem(2); }
if (x->getOption("InputDevice", sectNum, "BaudRate") == "") { kComboBox2->setCurrentItem(2); }
if (x->checkOption("InputDevice", sectNum, "AlwaysCore")) { checkBox2_2->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "Passive")) { checkBox2->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "InvertX")) { checkBox4->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "InvertY")) { checkBox4_2->setChecked(TRUE); }
if (x->checkOption("InputDevice", sectNum, "SwapXY")) { checkBox6->setChecked(TRUE); }


if (x->getOption("InputDevice", sectNum, "Rotate") == "") { kComboBox3->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "Rotate") == "CW") { kComboBox3->setCurrentItem(1); }
if (x->getOption("InputDevice", sectNum, "Rotate") == "CWW") { kComboBox3->setCurrentItem(2); }



if (x->getOptionNoBrackets("InputDevice", sectNum, "DebugLevel") != "")
{
bool ok;
int a = x->getOptionNoBrackets("InputDevice", sectNum, "DebugLevel").toInt(&ok, 10);
kIntSpinBox8->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MinimumXPosition") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "MinimumXPosition").toInt(&ok, 10);
kIntSpinBox9->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MaximumXPosition") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "MaximumXPosition").toInt(&ok, 10);
kIntSpinBox9_2->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MinimumYPosition") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "MinimumYPosition").toInt(&ok, 10);
kIntSpinBox9_3->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "MaximumYPosition") != "")
{
bool ok;
int a = x->getOption("InputDevice", sectNum, "MaximumYPosition").toInt(&ok, 10);
kIntSpinBox9_4->setValue(a);
}

}


void fpitDriverClass :: accept()
{
x->saveOption("InputDevice", sectNum, "DeviceName", 1, kLineEdit2->text());
if (kComboBox2->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "BaudRate", 1, "38400"); }
if (kComboBox2->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "BaudRate", 1, "19200"); }
if (kComboBox2->currentItem() == 2) { x->saveOption("InputDevice", sectNum, "BaudRate", 1, "9600"); }

QString num;
num = num.setNum(kIntSpinBox8->value(), 10);
x->removeOption("InputDevice", sectNum, "DebugLevel");
x->saveOptionNoBrackets("InputDevice", sectNum, "DebugLevel", 1, num);
if (checkBox2_2->isChecked()) { x->saveOption("InputDevice", sectNum, "AlwaysCore", 1, "True"); }
if (!checkBox2_2->isChecked()) { x->removeOption("InputDevice", sectNum, "AlwaysCore"); }
if (checkBox2->isChecked()) { x->saveOption("InputDevice", sectNum, "Passive", 1, "True"); }
if (!checkBox2->isChecked()) { x->removeOption("InputDevice", sectNum, "Passive"); }
if (checkBox4->isChecked()) { x->saveOption("InputDevice", sectNum, "InvertX", 1, "True"); }
if (!checkBox4->isChecked()) { x->removeOption("InputDevice", sectNum, "InvertX"); }
if (checkBox4_2->isChecked()) { x->saveOption("InputDevice", sectNum, "InvertY", 1, "True"); }
if (!checkBox4_2->isChecked()) { x->removeOption("InputDevice", sectNum, "InvertY"); }
if (checkBox6->isChecked()) { x->saveOption("InputDevice", sectNum, "SwapXY", 1, "True"); }
if (!checkBox6->isChecked()) { x->removeOption("InputDevice", sectNum, "SwapXY"); }
if (kComboBox3->currentItem() == 0) { x->removeOption("InputDevice", sectNum, "Rotate"); }
if (kComboBox3->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "Rotate", 1, "CW"); }
if (kComboBox3->currentItem() == 2) { x->saveOption("InputDevice", sectNum, "Rotate", 1, "CCW"); }
num = num.setNum(kIntSpinBox9->value(), 10);
x->saveOption("InputDevice", sectNum, "MinimumXPosition", 1, num);
num = num.setNum(kIntSpinBox9_2->value(), 10);
x->saveOption("InputDevice", sectNum, "MaximumXPosition", 1, num);
num = num.setNum(kIntSpinBox9_3->value(), 10);
x->saveOption("InputDevice", sectNum, "MinimumYPosition", 1, num);
num = num.setNum(kIntSpinBox9_4->value(), 10);
x->saveOption("InputDevice", sectNum, "MaximumYPosition", 1, num);



close();
}






QString fpitDriverClass :: returnXorg()
{
return x->returnConfig();
}

#include "fpitdriverclass.moc"
