/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kbdoptionsdialog.h"

#include <qcheckbox.h>
#include <qgroupbox.h>

#include <klineedit.h>
#include <knuminput.h>
#include <kcombobox.h>
#include <ksqueezedtextlabel.h>


kbdOptionsDialog::kbdOptionsDialog(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :kbd_keyboard_drv_options(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;
setLocale();
//Filling fields

if (x->getOption("InputDevice", sectNum, "Device") != "") 
{
checkBox51->setChecked(FALSE);
kLineEdit57->setText(x->getOption("InputDevice", sectNum, "Device"));
}


if (x->getOption("InputDevice", sectNum, "Protocol") != "")
{
checkBox135->setChecked(TRUE);
if (x->getOption("InputDevice", sectNum, "Protocol") == "Standard")
{
kComboBox63->setCurrentItem(0);
}
if (x->getOption("InputDevice", sectNum, "Protocol") == "Xqueue")
{
kComboBox63->setCurrentItem(1);
}
}

if (x->getOption("InputDevice", sectNum, "AutoRepeat") != "")
{
groupBox50->setChecked(TRUE);
QString delay = x->getOption("InputDevice", sectNum, "AutoRepeat").section(" ", 0, 0);
QString rate = x->getOption("InputDevice", sectNum, "AutoRepeat").section(" ", 1, 1);
bool ok;
int delayI = delay.toInt(&ok, 10);
int rateI = rate.toInt(&ok, 10);
kIntSpinBox26->setValue(delayI);
kIntSpinBox27->setValue(rateI);
}



}





QString kbdOptionsDialog :: returnXorg()
{
return x->returnConfig();
}

void kbdOptionsDialog::protocolUpdate()
{
if (checkBox135->isChecked()) { kComboBox63->setEnabled(TRUE); }
if (!checkBox135->isChecked()) { kComboBox63->setEnabled(FALSE); }
}

void kbdOptionsDialog :: update()
{
if (checkBox51->isChecked())
{
kLineEdit57->setEnabled(FALSE);
kSqueezedTextLabel174->setEnabled(FALSE);
}
if (!checkBox51->isChecked())
{
kLineEdit57->setEnabled(TRUE);
kSqueezedTextLabel174->setEnabled(TRUE);
}

}

void kbdOptionsDialog :: accept()
{
if (checkBox135->isChecked()) { 
if (kComboBox63->currentItem() == 0) { x->saveOption("InputDevice", sectNum, "Protocol", 1, "Standard"); }
if (kComboBox63->currentItem() == 1) { x->saveOption("InputDevice", sectNum, "Protocol", 1, "Xqueue"); }
}
if (!checkBox135->isChecked()) { x->removeOption("InputDevice", sectNum, "Protocol"); }
if (!checkBox51->isChecked()) { x->saveOption("InputDevice", sectNum, "Device", 1, kLineEdit57->text()); }
if (checkBox51->isChecked()) { x->removeOption("InputDevice", sectNum, "Device"); }

if (!groupBox50->isChecked()) { x->removeOption("InputDevice", sectNum, "AutoRepeat"); }
if (groupBox50->isChecked()) { 
QString num;
num = num.setNum(kIntSpinBox26->value(), 10);
QString num2;
num2 = num2.setNum(kIntSpinBox27->value(), 10);
num = num + " " + num2;
x->saveOption("InputDevice", sectNum, "AutoRepeat", 1, num); 
}


close();
}















#include "kbdoptionsdialog.moc"
