/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "vesadialogclass.h"

vesaDialogClass::vesaDialogClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :vesaDriverWindow(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;

if (x->checkOption("Device", sectNum, "ShadowFB")) { checkBox79->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "ModeSetClearScreen")) { checkBox80->setChecked(TRUE); }

}


QString vesaDialogClass :: returnXorg()
{
return x->returnConfig();
}

void vesaDialogClass :: accept()
{
QString y = "True";
if (checkBox79->isChecked()) { x->saveOption("Device", sectNum, "ShadowFB", 1, y); }
if (!checkBox79->isChecked()) { x->removeOption("Device", sectNum, "ShadowFB"); }
if (checkBox80->isChecked()) { x->saveOption("Device", sectNum, "ModeSetClearScreen", 1, y); }
if (!checkBox80->isChecked()) { x->removeOption("Device", sectNum, "ModeSetClearScreen"); }

close();
}

#include "vesadialogclass.moc"
